// The FsaTable class consolidates all the information required to
// generate the output file.  It also contains member functions to
// output this information in the required format.

class FsaTable {
	int states, initState, maxChar;
	short int **table;
	LexRule **final;
public:
	FsaTable(list<odfsaState *> *);
	void pr_nomodsWarning(FILE *ofdes);
	void pr_initialState(FILE *ofdes);
	void pr_states(FILE *ofdes);
	void pr_charSet(FILE *ofdes);
	void pr_prelude(FILE *ofdes);
	void pr_postlude(FILE *ofdes);
	void pr_finalStates(FILE *ofdes);
	void pr_filters(FILE *ofdes);
	void pr_stateTransition(FILE *ofdes);
};
