// The ParGenParser class specialises on the parser skeleton provided by
// the general Parser class.  It contains the recursive descent parser
// code which is specific to the language expected by ParGen.

class ParGenParser : public Parser {
public:

// The following functions form the recursive descent parser for ParGen,
// with the function specification() being the root.

	void specification(void);
	void rule(void);
	ParRule *ruleHead(void);
	void ruleBody(ParRule *);
	ParNode *expression(void);
	ParNode *termSeq(void);
	ParNode *term(void);

	static char *prelude;
	static char *postlude;
	static char *inhAttr;
	static char *currentfile;

	ParGenParser(char *n) : Parser(n) { currentfile = n; }
};
