
/* Web Polygraph       http://www.web-polygraph.org/
 * (C) 2003-2006 The Measurement Factory
 * Licensed under the Apache License, Version 2.0 */

#ifndef POLYGRAPH__CLIENT_WSSFREEZER_H
#define POLYGRAPH__CLIENT_WSSFREEZER_H

// base class for various objects that freeze working set size
class WssFreezer {
	public:
		virtual ~WssFreezer() {}
		virtual void start();

	protected:
		void startFill();
		void startFreeze();

		virtual void printGoal(ostream &os) const = 0;

	private:
		static int TheStartCount;
};

#endif
