
/* Web Polygraph       http://www.web-polygraph.org/
 * (C) 2003-2006 The Measurement Factory
 * Licensed under the Apache License, Version 2.0 */

#include "pgl/pgl.h"

#include "pgl/NetPipeSym.h"
#include "pgl/NetPipeArrIter.h"


NetPipeArrIter::NetPipeArrIter(CfgSyms &aCfgSyms, const Addrs *aLocalAddrs) {
	theCfgs = aCfgSyms;
	start(aLocalAddrs);
}

NetPipeSym *NetPipeArrIter::pipeSym() {
	return &(NetPipeSym&)cfgSym(theCfgIdx)->cast(NetPipeSym::TheType);
}

HostsBasedSym *NetPipeArrIter::cfgSym(int idx) const {
	return theCfgs[idx];
}

int NetPipeArrIter::cfgCount() const {
	return theCfgs.count();
}
