
/* Web Polygraph       http://www.web-polygraph.org/
 * (C) 2003-2006 The Measurement Factory
 * Licensed under the Apache License, Version 2.0 */

#ifndef POLYGRAPH__PGL_NETPIPEARRITER_H
#define POLYGRAPH__PGL_NETPIPEARRITER_H

#include "pgl/HostsBasedIter.h"

class NetPipeSym;

// agent array iterator, based on HostsBasedIter
class NetPipeArrIter: public HostsBasedIter {
	public:
		typedef Array<NetPipeSym*> CfgSyms;

	public:
		NetPipeArrIter(CfgSyms &aCfgSyms, const Addrs *aLocalAddrs = 0);

		NetPipeSym *pipeSym();

	protected:
		HostsBasedSym *cfgSym(int idx) const;
		virtual int cfgCount() const;

	protected:
		CfgSyms theCfgs;
};

#endif
