// The Parser class defines a skeleton parser.
// It allows for the following:
//
//    i)   inheriting from the Lexer class
//    ii)  anticipating expected symbols
//    iii) reporting parsing errors.

class Parser : public Lexer {
protected:
	void mustBe(symbols);
	void expect(symbols);
	void parseError(char *);
	Parser(char *n) : Lexer(n) { }
};
